Subject: Bug#1200: [X2Go-Dev] Environment variables not set

From: Bruno CAPELETO <[email-masked]>
Date: Wed, 16 Aug 2017 11:17:42 +0200

2017-08-11 5:29 GMT+02:00 Mihai Moldovan <[email-masked]>:

> Control: reassign -1 x2goserver 4.0.1.20
>
> First of all, x2goserver 4.0.1.20 actually is the correct stable release.
> 4.1.0.0 are the current nightly releases.
>
> I personally don't care much about what version is tested, but knowing
> whether
> there's a difference in behavior between the stable and nightly versions is
> certainly helpful.
>

Same issues with both versions.

>
>
> On 08/10/2017 12:24 PM, Bruno CAPELETO wrote:
> > Package: <x2goserver> Version: <4.0.1.20-0x2go1+git20170412.
> 1125+9.main.1>
> >
> > # uname -a Linux mtcie1 4.9.0-3-amd64 #1 SMP Debian 4.9.30-2+deb9u1
> > (2017-06-18) x86_64 GNU/Linux
> >
> >
> >
> > The below bugs are most probably related to each other, that's why I open
> > one case for all of them.
> >
> > The issues are the following : I want to use the French software Laurux,
> > which is based on Gambas interpreter, via a x2go session running on a
> Debian
> > 9 server running LXDE (same issues seen on an Ubuntu server, x2goserver
> > version = 4.0.1.20-0~1125~ubuntu14.04.1)..
> >
> > As a prerequisite, the software is installed on the server and runs well
> on
> > a local session.
> >
> > 1. Whatever the client (Windows or Linux 4.0.3.1-4), the local
> environment
> > variables are not set properly and the software - which needs French
> > localization - crashes. That could be "solved" the following way :
> > /etc/x2go/Xsession :
> >
> > ... LANG=fr LC_ALL=fr_FR.UTF-8 export LANG export LC_ALL ...
> >
> > That seems to be a revival of older bugs, but it is definitely still
> here.
>
> How exactly did you set the locale?
>
> The "Debian way" would be to run dpkg-reconfigure locales as root and
> select the
> desired locale(s) to generate and then select the default one.
>

That is exactly the way  I set the locales.

>
> /etc/environment should not contain any locale settings.
>

/etc/environmnent is empty

>
> LANGUAGES and especially LC_ALL should normally not be set. LANGUAGES is a
> GNU-only list of fallback locales. LANG is the preferred way to set the
> locale,
> since it's being used if all of the LC_* env variables are empty.
> "dpkg-reconfigure locales" will do the right thing™.
>

I confirm $LANGUAGES and $LC_ALL are not set on a local session.

>
>
> > 2. At the start of a new session, one gets a windows with an error
> message
> > "No session for pid ..." ; that bug has already been reported several
> times
> > in x2go bug tracking and marked as solved. Actually it is not on my
> brand new
> > system.
>
> What session are you starting exactly? I cannot find the string "No
> session for
> pid" in x2goserver's source code. Not sure what to do with this.
>

I found out it is a reported bug related to LXDE : cf
https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=864402

>
>
> > 3. The single application mode does not work with some of the
> applications,
> > including that Laurux / Gambas. For example it works with
> /usr/bin/leafpad,
> > but /usr/bin/libreoffice makes the x2go session crash.
>
> That's certainly possible. The most likely cause, as Uli explained, is
> that the
> command daemonizes itself right after launching it. This leads to the X2Go
> scripts assuming that the program exited and subsequently also terminating
> the
> session. We've seen such behavior every now and then and worked around it.
>
> However, it looks like x2goagent is crashing when you start libreoffice in
> your
> case. That shouldn't happen. My gut feeling is that this might be another
> GTK3
> incompatibility.
>
> I could try to reproduce this in a clean stretch VM.
>

Perfectly reproducible in my case on 2 installations.

>
>
> > 4. The mouse double clic does not work in a x2go session, but only -
> within
> > the Gambas software (works well for example when launching an
> application)
> > and only - when the x2go client is running in a Windows environment (no
> > problem when client in a Linux environment)
>
> That sounds like Gambas is doing something funny, though. As far as I was
> able
> to gather, Gambas seems to be using Qt5 as its drawing toolkit.
>
> The package qtbase5-examples should contain a binary at
> /usr/lib/x86_64-linux-gnu/qt5/examples/widgets/widgets/
> mousebuttons/mousebuttons
> which spits out received mouse events.
>
> Can you try that - especially with double clicking - and see what it
> outputs?
>

$
/usr/lib/x86_64-linux-gnu/qt5/examples/widgets/widgets/mousebuttons/mousebuttons
failed to get the current screen resources
QXcbConnection: XCB error: 172 (Unknown), sequence: 169, resource id: 175,
major code: 149 (Unknown), minor code: 20
"Mouse Press: raw button=1  Qt=LeftButton\n heldbuttons LeftButton "
"Mouse Release: raw button=1  Qt=LeftButton\n heldbuttons NoButton"
"Mouse DoubleClick: raw button=1  Qt=LeftButton\n heldbuttonsLeftButton "
"Mouse Release: raw button=1  Qt=LeftButton\n heldbuttons NoButton"

Reminder : the double click works when for example I launch an application
from the desktop shortcut.
It is only in this gambas software that it does not work, and only when
using x2go Windows client (works perfectly well with x2go linux client).

> Mihai